const generator = require('./generator');
const AST = require('../core/ast');
const logger = require('./log');

module.exports = {
  fromFile: (file, opt) => {
    logger.shouldShow(opt && opt.log);
    const ast = new AST();
    ast.fromFile(file);
    return generator(ast, { mock: true, keepComment: false, ...opt });
  },
  fromCode: (code, fileName, opt) => {
    logger.shouldShow(opt && opt.log);
    const ast = new AST();
    ast.fromCode(code, fileName);
    return generator(ast, { mock: true, keepComment: false, ...opt });
  },
};
