const path = require('path');
const { getOptions } = require('loader-utils');
const transform = require('./api.ts');
const kinds = require('./api.ts/kinds');

// @ali/api-runtime < package.json("@api-loader-kinds") < api.config.js
const defaultKinds = [
  '@ali/api-runtime',
  require(`${process.cwd() + path.sep}package.json`)['@api-loader-config'],
  `${process.cwd() + path.sep}api.config.js`,
];

let hasSetKinds = false;

/**
 * Webpack loader see:
 * https://webpack.js.org/contribute/writing-a-loader/
 */
function processChunk(source) {
  const options = getOptions(this);
  if (options.kind) {
    kinds.setKinds(options.kind);
  }
  if (!hasSetKinds) {
    hasSetKinds = true;
    // 去重
    const mergedSolutions = defaultKinds.filter((value, index, self) => value && self.indexOf(value) === index);
    kinds.setKinds(mergedSolutions);
  }
  return transform.fromCode(source, this.resourcePath, options);
}

module.exports = processChunk;
