export type TApiOld = {
  aliasName: string,
  gatewayType: number,
  basePath: string,
  replica: number,
  regionName: string,
  name: string,
  runtimeOn: string,
  id: number,
  region: number,
  networkSegment: string,
  status: string
};

export type TApi = {
  aliasName: string, //别名
  attachedService: TServiceApi[],
  basePath: string,
  creationDataTime: string,
  description: string,
  id: number,
  name: string,
  owneredPolicies: TPolicyApi[],
  publishedGateway: TGatewayApi,
  status: number, // unpublished, unpublishedEditing, publishing, published, publishedEditing, recycling 
  updateDateTime: string
};

export type TGatewayApi = {
  aliasName: string,
  basePath: string,
  gatewayType: number,
  id: number,
  name: string,
  region: number,
  regionName: string,
  replica: number,
  runtimeOn: string, // Kubernetes, ECS
  securityGroup: string,
  status: string, // new, initializing, available, shrinking, expanding, recycling, destroyed
  vswitch: string
};

export type TServiceApi = {
  id: number,
  isAutoRefresh: boolean,
  isHealth: boolean,
  name: string,
  serviceNodes: TServiceNode[]
};

export type TServiceNode = {
  id: number,
  ip: string,
  isHealth: boolean,
  owneredService: TServiceApi,
  port: number
  self: 
};

export type TPolicyApi = {

};